<template>
  <v-container fluid ma-0 pa-2 white>
    <v-row class="mr-5 ml-1 mb-0 pb-0">
      <v-col cols="12" sm="1" md="1">
        <v-text-field
            v-model="team"
            :items="team"
            label="Team"
            hide-details
          ></v-text-field>
      </v-col>
      <v-col cols="12" sm="1" md="1">
          <v-select
            v-model="valueBoard.id"
            :items="itemsBoard"
            label="Board Name"
            item-text="name"
            item-value="id"
            return-object
            hide-details
            @change="boardChange()"
          ></v-select>
      </v-col>
      <v-col cols="12" sm="2" md="2">
        <v-select
            v-model="valueProject.key"
            :items="itemsProject"
            label="Project Name"
            item-text="name"
            item-value="key"
            multiple
            hide-details
            return-object
          ></v-select>
      </v-col>
      <v-col cols="12" sm="2" md="2">
        <v-menu
          ref="menu"
          v-model="menu"
          :close-on-content-click="false"
          :return-value.sync="date"
          transition="scale-transition"
          offset-y
          hide-details
          min-width="auto"
        >
          <template v-slot:activator="{ on, attrs }">
            <v-text-field
              v-model="date"
              label="Start Date"
              prepend-icon="mdi-calendar"
              readonly
              v-bind="attrs"
              v-on="on"
              hide-details
            ></v-text-field>
          </template>
          <v-date-picker v-model="date" no-title scrollable>
            <v-spacer></v-spacer>
            <v-btn text color="primary" @click="menu = false"> Cancel </v-btn>
            <v-btn text color="primary" @click="$refs.menu.save(date)">
              OK
            </v-btn>
          </v-date-picker>
        </v-menu>
      </v-col>
      <v-col cols="12" sm="2" md="2">
        <v-menu
          ref="menu2"
          v-model="menu2"
          :close-on-content-click="false"
          :return-value.sync="date2"
          transition="scale-transition"
          offset-y
          min-width="auto"
          hide-details
        >
          <template v-slot:activator="{ on, attrs }">
            <v-text-field
              v-model="date2"
              label="End Date"
              prepend-icon="mdi-calendar"
              readonly
              v-bind="attrs"
              v-on="on"
              hide-details
            ></v-text-field>
          </template>
          <v-date-picker v-model="date2" no-title scrollable>
            <v-spacer></v-spacer>
            <v-btn text color="primary" @click="menu2 = false"> Cancel </v-btn>
            <v-btn text color="primary" @click="$refs.menu2.save(date2)">
              OK
            </v-btn>
          </v-date-picker>
        </v-menu>
      </v-col>
      <v-col cols="12" sm="1" md="1">
        <v-text-field
          v-model="efforJsonList.jiraDev"
          counter="50"
          hint="Jira ticket"
          label="Jira ticket"
          hide-details
        ></v-text-field>
      </v-col>
      <v-col cols="12" sm="1" md="1" class="pt-5 text-right">
        <v-btn color="success" @click="createWeeklyReport()" :disabled='btnDisable'> Create Report</v-btn>
      </v-col>
      <v-col cols="12" sm="1" md="1" class="pt-5 text-left">
        <v-btn color="success" @click="getWorklogByTicket()" :disabled='btnDisable'> Search by  Jira Ticket</v-btn>
      </v-col>
      
    </v-row>
    <!-- member -->
    <v-row v-show="false">
      <v-col cols="12" sm="8" md="8">
        <v-select
          v-model="member.userName"
          :items="itemsMember"
          label="Members"
          item-text="displayName"
          item-value="userName"
          multiple
          hide-details
          return-object
        ></v-select>
      </v-col>
      <v-col cols="12" sm="4" md="4">
        <v-select
          v-model="weekly.key"
          :items="itemsWeekly"
          label="Weekly Report"
          item-text="name"
          item-value="key"
          hide-details
          return-object
        ></v-select>
      </v-col>
    </v-row>
    <v-row v-show="false">
      <v-col cols="12" sm="3" md="3">
        <v-text-field
          v-model="efforJsonList.userName"
          counter="100"
          hint="User Name"
          label="User Name (*)"
        ></v-text-field>
      </v-col>
      <v-col cols="12" sm="3" md="3">
        <v-text-field
          v-model="efforJsonList.pwd"
          counter="50"
          type="password"
          hint="Passsword (*)"
          label="Passsword"
        ></v-text-field>
      </v-col>
      
      
    </v-row>

    <v-row>
      <v-col cols="12" sm="12" :md="isShow ? 7 : 12" class="ma-0 pb-0 pt-0">
        <v-row>
          <v-col cols="3">
            <h3 class="bold">Sheet DLB System_Task</h3> 
            
          </v-col>
          <v-col cols="3">
            <span> </span>
            <v-checkbox
              label="Show KPI Sheet"
              hide-details
              v-model="isShow"
            />
          </v-col>
          <v-col cols="6" class="text-right">
            <a href="https://docs.google.com/spreadsheets/d/1ZtFaV_gkQHNDQBdiV6fFoy19QJiluiZgIa-kGsCPiYk/edit#gid=2081726550">
            EDI (AnhLe)_V2-NamNN-Task
            </a>
          </v-col>
          <v-col cols="12" sm="12" md="12" class="pt-0">
            <hot-table ref="hotTableComponent" :settings="hotSettings"> </hot-table>
          </v-col>
        </v-row>
      </v-col>
      <v-col cols="12" sm="12" :md="isShow ? 5 : 0" class="ma-0 pb-0 pt-0" v-show="isShow">
        <v-col cols="12" sm="12" md="12" class="mb-0 pb-0">
          <h3>SLO_KPI - Smartlink KPI<span style="color:red"> {{this.jiraIdSeleted}}: {{this.jiraIdTotalHour}} hour</span></h3>
        </v-col>
        
        <!-- <v-col cols="12" sm="5" md="5" class="mb-0 pb-0">
          <h3>Smartlink KPI <span style="color:red"> {{this.jiraIdSeleted}}: {{this.jiraIdTotalHour}} hour</span></h3>
        </v-col> -->
        <v-row class="ml-1 mr-1">
          <v-col cols="12" md="2" class="mb-0 pb-0">
            <v-btn color="warning" @click="checkKPI(); loadExcel()"> Check KPI</v-btn>
            
          </v-col>
          <v-col cols="12" md="2" class="mb-0 pb-0">
            <v-text-field
              v-model="monthDifference"
              counter="100"
              hint="Month ago (Month)"
              label="Month ago (Month)"
              hide-details
            />
          </v-col>
          <v-col cols="12" md="2" class="mb-0 pb-0">
            <h4 class="orange pa-2 text-center text-bold">SLO != SOG</h4>
          </v-col>
          <v-col cols="12" md="3" class="mb-0 pb-0">
            <h4 class="yellow pa-2 text-center text-bold">SLO != SML KPI</h4>
          </v-col>
          <!-- <v-col cols="12" sm="6" md="6">
            <h3 class="yellow pa-2 text-center text-bold">SOL Input</h3>
          </v-col> -->
        </v-row>
        <v-col cols="12" sm="12" md="12">
            <hot-table ref="hotTableSOGLogs" :settings="hotSettingsSOGLogs"> </hot-table>
        </v-col>
        <!-- <v-col cols="12" sm="12" md="12">
            <hot-table ref="hotSettingsSOLKPI" :settings="hotSettingsSOLKPI"> </hot-table>
        </v-col> -->
        <!-- <v-col cols="12" sm="6" md="6">
            <hot-table ref="hotTableSOGLogs" :settings="hotSettingsSOGLogs"> </hot-table>
        </v-col> -->
       </v-col>
    </v-row>
    <v-overlay :value="overlay">
      <v-progress-circular
        indeterminate
        size="64"
      ></v-progress-circular>
    </v-overlay>
  </v-container>
</template>
<script>
import axios from "axios";
import moment from "moment";
import momentBiz from 'moment-business-days';
import config from "../../../config/config";
// import VueJsonPretty from "vue-json-pretty";
// import "vue-json-pretty/lib/styles.css";
import cookieClient from "vue-cookie";
import vueJsonEditor from "vue-json-editor";
import { HotTable } from "@handsontable-pro/vue";
import Handsontable from "handsontable";
// import '~handsontable/dist/handsontable.full.css'
import "handsontable-pro/dist/handsontable.full.css";

export default {
  components: {
    // VueJsonPretty,
    HotTable,
    vueJsonEditor,
    // Loading,
  },
  data() {
    let self = this;
    return {
      date: new Date().toISOString().substr(0, 10),
      date2: new Date().toISOString().substr(0, 10),
      menu: false,
      menu2: false,
      isShow: true,
      clvKPI: [],
      team: "Smartlink",
      projectsName: "SPKA",
      valueBoard: {},
      itemsBoard: [],
      valueProject:{},
      itemsProject: [],
      isBtnDisable: false,
      ticketJson: [],
      jiraLinkRoot:
        "https://pim.cyberlogitec.com/jira/rest/clt-gadget/latest/getWorklogByUser.json?",
      jiraLink: "",
      userName:"",
      pwd: "",
      jiraDev:"",
      member: {},
      //startdate=2021-04-01&enddate=2021-04-30&projects=SPKA,
      itemsMember: [
        {
          userName: 'nam.nguyenngoc',
          displayName: 'Nam Nguyen Ngoc'
        },
        {
          userName: '203737',
          displayName: 'Dung cao'
        },
        {
          userName: '203728',
          displayName: 'Khanh Nguyen'
        },
      ],
      efforJsonList: {
        jiraLink: "",
        userName:"",
        pwd: "",
        jiraDev:"",
        from: this.date,
        to: this.date2,
        // projectsName: "SmartLink [Internal]",
        month: 5,
        week: 10,
        year: 2021,
        NAM: {
          member: "Nam Nguyen Ngoc",
          account: "nam.nguyenngoc",
          jiraLog: [],
          jiraTicketByTimeH: [],
          total: {},
        },
        DUNG: {
          member: "Dung Cao",
          account: "203737",
          jiraLog: [],
          jiraTicketByTimeH: [],
          total: {},
        },
        KHANH: {
          member: "Khanh Nguyen",
          account: "203728",
          jiraLog: [],
          jiraTicketByTimeH: [],
          total: {},
        },
      },
      pimDATA: [],
      hotSettings: {
        copyPaste: true,
        // data: this.pimDATA,
        startRows: 1000,
        startCols: 15,
        stretchH: "all",
        autoWrapRow: true,
        height: 600,
        maxRows: 1000,
        rowHeaders: true,
        colHeaders: true,
        filters: true,
        multiColumnSorting: true,
        columns: [
          {
            data: "reported",
            width: 10,
          },
          {
            data: "WeekReport",
            width: 90,
          },
          {
            data: "TaskID",
            width: 80,
          },
          {
            data: "Remark",
            width: 10,
          },
          {
            data: "TaskName",
          },
          {
            data: "Type",
            width: 80,
          },
          {
            data: "StatusTask",
            width: 90,
          },
          {
            data: "NewReq",
            width: 80,
          },
          {
            data: "QtyIssues",
            width: 90,
          },
          {
            data: "ReportDate",
             width: 90,
          },
          {
            data: "ChanelReceive",
            width: 110,
          },
          {
            data: "Description",
            width: 110,
          },
          {
            data: "Taskconent",
            text: "right",
            width: 90,
          },
        ],
        colHeaders: [
          "RP",
          "Week Report",
          "Task ID",
          "RMK",
          "Task Name / Short discription",
          "Type",
          "Status Task",
          "New Req",
          "Qty Issues",
          "Report Date",
          "Chanel Receive",
          "Description",
          "Task Conent"
        ],
        multiColumnSorting: {
          sortEmptyCells: true,
          initialConfig: [ {
            // column: 11,
            // sortOrder: 'desc'
          }]
        },
        contextMenu: true,
        dropdownMenu: ['filter_by_condition', 'filter_action_bar', 'filter_by_value'],
        language: "en-US",
        afterChange: () => {},
        cells: function(row, col) {
          if (col === 1 || col === 2) {
            this.renderer = self.weeklyRender;
          }
        },
        afterOnCellMouseDown: function () {
          var cell = this;
          console.log('value', cell.getValue());
          let selected = cell.getSelected();
          if(selected != undefined && selected[0][1] == 15){
            let data = cell.getData();
            let jiraID = cell.getValue();
            self.getWorklogByTicketOfline(cell.getSourceData(), data, jiraID);
          }
        },
        afterCreateRow: function (index, amount) {
            // self.hotSettings.handsontable('setDataAtCell', index-1, 1, '0');
        }
         

      },
      flagRowOld: 0,
      hotSettingsSOGLogs: {
        copyPaste: true,
        // data: this.pimDATA,
        startRows: 1000,
        startCols: 15,
        stretchH: "all",
        autoWrapRow: true,
        height: 550,
        maxRows: 1000,
        rowHeaders: true,
        colHeaders: true,
        filters: true,
        multiColumnSorting: true,
        columns: [
          {
            data: "userId",
            width: 90,
          },
          {
            data: "displayName",
            width: 200,
          },
          {
            data: "effortDate",
            width: 160,
            type: 'date',
            dateFormat: 'YYYY-MM-DD',
            correctFormat: true,
            sortOrder: 'desc',
          },
          {
            data: "sogActEffort",
            width: 160,
            type: 'numeric',
          },
          // {
          //   data: "sloEstEffort",
          //   width: 160,
          // },
          {
            data: "sloActEffort",
            width: 160,
            type: 'numeric',
          },
          {
            data: "smlActEffort",
            width: 160,
            type: 'numeric',
          }
        ],
        colHeaders: [
          "UserId",
          "DisplayName",
          "Effort Date",
          // "SLO-EST Effort",
          "SOG-ACT Effort",
          "SLO-ACT Effort",
          // "SmartLinkKPI-EST Effort",
          "SmartLinkKPI-ACT Effort",
        ],
        multiColumnSorting: {
          sortEmptyCells: true,
          initialConfig: [ 
          {
            column: 2,
            sortOrder: 'desc'
          }]
        },
        contextMenu: true,
        dropdownMenu: ['filter_by_condition', 'filter_action_bar', 'filter_by_value'],
        language: "en-US",
        cells: function(row, col) {
          if (col === 3 || col === 4 || col === 5) {
            this.renderer = self.stsSRCRender;
          }
          if((self.flagRowOld == row || self.flagRowOld == 0) && col < 5){
            this.renderer = self.rowEvent;
            self.flagRowOld += 3;
          }

          
        },
        afterChange: () => {},
        // afterOnCellMouseDown: function () {
          //   var cell = this;
          //   console.log('value', cell.getValue());
          //   let selected = cell.getSelected();
          //   if(selected != undefined && selected[0][1] == 15){
          //     let data = cell.getData();
          //     let jiraID = cell.getValue();
          //     self.getWorklogByTicketOfline(data, jiraID);
          //   }
          // }
         

      },
      hotSettingsSOLKPI: {
        copyPaste: true,
        // data: this.pimDATA,
        startRows: 1000,
        startCols: 15,
        stretchH: "all",
        autoWrapRow: true,
        height: 500,
        maxRows: 1000,
        rowHeaders: true,
        colHeaders: true,
        filters: true,
        multiColumnSorting: true,
        // columns: [
        //   {
        //     data: "userId",
        //     width: 90,
        //   },
        //   {
        //     data: "displayName",
        //     width: 200,
        //   },
        //   {
        //     data: "effortDate",
        //     width: 160,
        //     type: 'date',
        //     dateFormat: 'YYYY-MM-DD',
        //     correctFormat: true,
        //     sortOrder: 'desc',
        //   },
        //   {
        //     data: "sogActEffort",
        //     width: 160,
        //     type: 'numeric',
        //   },
        //   // {
        //   //   data: "sloEstEffort",
        //   //   width: 160,
        //   // },
        //   {
        //     data: "sloActEffort",
        //     width: 160,
        //     type: 'numeric',
        //   },
        //   {
        //     data: "smlActEffort",
        //     width: 160,
        //     type: 'numeric',
        //   }
        // ],
        // colHeaders: [
        //   "UserId",
        //   "DisplayName",
        //   "Effort Date",
        //   // "SLO-EST Effort",
        //   "SOG-ACT Effort",
        //   "SLO-ACT Effort",
        //   // "SmartLinkKPI-EST Effort",
        //   "SmartLinkKPI-ACT Effort",
        // ],
        multiColumnSorting: {
          sortEmptyCells: true,
          initialConfig: [ 
          {
            column: 2,
            sortOrder: 'desc'
          }]
        },
        contextMenu: true,
        dropdownMenu: ['filter_by_condition', 'filter_action_bar', 'filter_by_value'],
        language: "en-US",
        cells: function(row, col) {
          if (col === 3 || col === 4 || col === 5) {
            this.renderer = self.stsSRCRender;
          }
          if((self.flagRowOld == row || self.flagRowOld == 0) && col < 5){
            this.renderer = self.rowEvent;
            self.flagRowOld += 3;
          }
        },
        afterChange: () => {},
        // afterOnCellMouseDown: function () {
          //   var cell = this;
          //   console.log('value', cell.getValue());
          //   let selected = cell.getSelected();
          //   if(selected != undefined && selected[0][1] == 15){
          //     let data = cell.getData();
          //     let jiraID = cell.getValue();
          //     self.getWorklogByTicketOfline(data, jiraID);
          //   }
          // }
         

      },
      overlay: false,
      rowWorkLogs: [],
      jiraIdSeleted: "",
      jiraIdTotalHour: 0,
      itemsWeekly: [
        // {
        //   "key":momentBiz(momentBiz(new Date()).startOf('isoWeek').isoWeekday(2), "YYYY-MM-DD").businessSubtract(3),
        //   "name": momentBiz(momentBiz(new Date()).startOf('isoWeek').isoWeekday(2), "YYYY-MM-DD").businessSubtract(3)
        // }
      ],
      weekly: {},
      monthDifference: 1,
      lstMember: {},
    };
  },
  created() {
    let userName = self.$cookies.get('userName');
    if(config.userValid.includes(userName)){
      console.log("userName", userName);
    }else{
      return
    }

    momentBiz.updateLocale('us', {
      holidays: this.holidays,
      holidayFormat: 'YYYY-MM-DD'
    });
    //businessSubtract(-3)
    let dateStartWeek = momentBiz(momentBiz(new Date()).startOf('isoWeek').isoWeekday(2), "YYYY-MM-DD").businessSubtract(3);
    let dateEndWeek = momentBiz(momentBiz(new Date()).startOf('isoWeek').isoWeekday(2), "YYYY-MM-DD").businessSubtract(-1);
    console.log("from", new Date(momentBiz(dateStartWeek, 'YYYY-MM-DD')._d).toISOString().substr(0, 10));
    console.log("to", new Date(momentBiz(dateEndWeek, 'YYYY-MM-DD')._d).toISOString().substr(0, 10));

    this.date = new Date(momentBiz(dateStartWeek, 'YYYY-MM-DD')._d).toISOString().substr(0, 10);
    this.date2 = new Date(momentBiz(dateEndWeek, 'YYYY-MM-DD')._d).toISOString().substr(0, 10);
    
    // this.jiraBoards();
    this.itemsBoard = JSON.parse(this.$cookies.get('boardList'));
    this.efforJsonList.userName = this.$cookies.get('userName');
    this.efforJsonList.pwd = this.$cookies.get('pwd');

     let dateStartWeek2 = momentBiz(momentBiz(new Date('2021-06-09')).startOf('isoWeek').isoWeekday(2), "YYYY-MM-DD").businessSubtract(-7);
     let dt = '2021-06-20T00:00:00';
     console.log("-------------------------------------------------------------------");
     console.log('2021-06-07T00:00:00', momentBiz(moment('2021-06-07T00:00:00').utcOffset('+0700')).startOf('isoWeek').isoWeekday(1)._d);
     console.log(momentBiz(moment('2021-06-07T00:00:00').utcOffset('+0700')).startOf('isoWeek').isoWeekday(1));
     console.log('2021-06-08T00:00:00', this.getWklyreport('2021-06-08T00:00:00'));
     console.log('2021-06-09T00:00:00',this.getWklyreport('2021-06-09T00:00:00'));
     console.log('2021-06-10T00:00:00',this.getWklyreport('2021-06-10T00:00:00'));
     console.log('2021-06-11T00:00:00',this.getWklyreport('2021-06-11T00:00:00'));
     console.log('2021-06-14T00:00:00',this.getWklyreport('2021-06-14T00:00:00'));
     console.log('2021-06-15T00:00:00',this.getWklyreport('2021-06-15T00:00:00'));
     console.log('2021-06-16T00:00:00',this.getWklyreport('2021-06-16T00:00:00'));
     console.log('2021-06-17T00:00:00',this.getWklyreport('2021-06-17T00:00:00'));
     console.log('2021-06-18T00:00:00',this.getWklyreport('2021-06-18T00:00:00'));
     console.log(momentBiz(moment('2021-06-18T00:00:00').utcOffset('+0700')).startOf('isoWeek').isoWeekday(4).isoWeekday());
     console.log("-------------------------------------------------------------------");
    console.log("Next wk report : ", momentBiz(momentBiz(moment(dt)
                  .utcOffset('+0700')).startOf('week').isoWeekday(3), "YYYY-MM-DD").businessSubtract(-10).format("MMM-DD"));
    //create weekly report 
    
    this.itemsWeekly.push({
      "key": moment(this.date).format('MMM - DD'),
      "name": moment(this.date).format('MMM - DD')
    },
    {
      "key": moment(this.date2).format('MMM - DD'),
      "name": moment(this.date2).format('MMM - DD')
    })
  },
  mounted() {
    // this.createWeeklyReport();
  },
  watch: {
    date(newVal) {
      // console.log('item changed', newVal);
      this.jiraLink = `https://pim.cyberlogitec.com/jira/rest/clt-gadget/latest/getWorklogByUser.json?startdate=${newVal}&enddate=${this.date2}&projects=${this.projectsName}`;
    },
    date2(newVal) {
      // console.log('item changed', newVal);
      this.jiraLink = `https://pim.cyberlogitec.com/jira/rest/clt-gadget/latest/getWorklogByUser.json?startdate=${this.date}&enddate=${newVal}&projects=${this.projectsName}`;
    },

    btnDisable(){
      // return true
      // if(this.efforJsonList.userName != undefined && this.efforJsonList.userName.trim().length > 0){
      // }
    },
    // overlay (val) {
    //     val && setTimeout(() => {
    //       this.overlay = false
    //     }, 3000)
    //   },
  },
  computed: {
     btnDisable: function () {
       // must parse because Vue turns empty value to string
      if(this.valueBoard.id != undefined 
        && !this.isBtnDisable){
         return false;
      }
      return true;
     },
     boardDisable: function () {
       // must parse because Vue turns empty value to string
      if(!this.isBtnDisable){
         return false;
      }
      return true;
     }
  },
  methods: {
    workday_count(start, end) {
      var first = start.clone().endOf("week"); // end of first week
      var last = end.clone().startOf("week"); // start of last week
      var days = (last.diff(first, "days") * 5) / 7; // this will always multiply of 7
      var wfirst = first.day() - start.day(); // check first week
      if (start.day() == 0) --wfirst; // -1 if start with sunday
      var wlast = end.day() - last.day(); // check last week
      if (end.day() == 6) --wlast; // -1 if end with saturday
      return wfirst + Math.floor(days) + wlast; // get the total
    }, //              ^ EDIT: if days count less than 7 so no decimal point
    onJsonChange(value) {
      var ftest = { date: "2015-02-0", start: 1, end: 7 };
      var ltest = { date: "2015-02-2", start: 2, end: 8 };
      var f = "YYYY-MM-DD";
      var start = moment(ftest.date).add(-1,'days');
      var end = moment(ltest.date).add(1,'days');
      var wd = this.workday_count(start, end);
      console.log("valuewd:", wd);
      // this.efforJsonList.NAM.jiraTicketByTimeH = this.efforJsonList.NAM.jiraLog;
      if (undefined != value) {
        let ticket = null;
        let times = 0;
        this.efforJsonList.NAM.total = {};
        this.efforJsonList.NAM.jiraTicketByTimeH = [];
        for (var i = 0; i < value.issues.length; i++) {
          times += value.issues[i].Worklog / 60 / 60;
          ticket = {
            Issue: value.issues[i].Issue,
            Worklog: value.issues[i].Worklog / 60 / 60,
          };

          this.efforJsonList.NAM.jiraTicketByTimeH.push(ticket);

          //   console.log('valuedd:', this.efforJsonList.NAM.jiraLog.issues[i]);
          //  console.log('index:', i);
        }

        this.efforJsonList.NAM.total.countTicket =
          this.efforJsonList.NAM.jiraTicketByTimeH != undefined
            ? this.efforJsonList.NAM.jiraTicketByTimeH.length
            : 0;
        this.efforJsonList.NAM.total.times = times;
      }
    },
    getWklyreport(date){
      // J788-WEEKDAY(J788,3)+if(and(WEEKDAY(J788,3)<=4,WEEKDAY(J788,3)>=2),2,-5))+7, "")
      let wday = momentBiz(moment(date).utcOffset('+0700')).isoWeekday();
      console.log("wday", wday);
      let dateString = null;
      let deta = wday;
      let iSub = 0;
      switch (deta) {
        case 1:
          iSub = 3;
          break;
        case 2:
          iSub = 3;
          break;
        case 3:
          iSub = -2;
          break;
        case 4:
          iSub = -2;
          break;
        case 5:
          iSub = -2;
          break;
      
        default:
          break;
      }
      // dateString = momentBiz(date).businessSubtract(wday + (wday < 3 && wday >=1) ? 2 : -5).format("MMM-DD");
      dateString = momentBiz(date).businessSubtract((wday-1)+iSub).format("MMM-DD");
      // dateString = momentBiz(date).businessSubtract(wday >=3 ? wday-3 : wday-6).format("MMM-DD");
      return dateString;
    },

    getEffortJira() {
      this.$cookies.set(
        "crowd.cltems.token_key",
        "lqlZJuuqyynVh4KuuPqGWwAAAAAACYACZG91ZGV2bm4",
        "expiring time"
      );
      this.$cookies.set(
        "JSESSIONID",
        "C0D57CF498029BB85160DB217A0CCA7B",
        "expiring time"
      );
      this.$cookies.set(
        "atlassian.xsrf.token",
        "OX6K_db721eb8bbc90605be85a4afc21424a1def1ec59_lin",
        "expiring time"
      );
      // console.log("CK", this.$cookies.get("NID"));
      axios
        .get(this.jiraLink, {
          headers: {
            cookie:
              "crowd.cltems.token_key=lqlZJuuqyynVh4KuuPqGWwAAAAAACYACZG91ZGV2bm4; JSESSIONID=C0D57CF498029BB85160DB217A0CCA7B; atlassian.xsrf.token=OX6K_db721eb8bbc90605be85a4afc21424a1def1ec59_lin;",
          },
        })
        .then(function (response) {
          console.log("readfolder", response);
        });
    },
    async Insert(member) {
      let seft = this;
      this.efforJsonList.week = parseInt(seft.date.split("-")[1]);
      this.efforJsonList.month = parseInt(seft.date.split("-")[1]);
      this.efforJsonList.year = parseInt(seft.date.split("-")[0]);
      console.log(this.efforJsonList);
      await axios
        .post(config.API_JIRA + "/api/insertKPI", this.efforJsonList)
        .then(function (response) {});
    },
    async reloadBoard(){
      this.jiraBoards();
    },
    async jiraBoards(){
      const seft = this;
      seft.overlay = true;
      await axios
        .post(`${config.API_JIRA}/api/jiraBoards`, this.efforJsonList)
        .then(async function (response) {
          // seft.hotSettings.data = response.data.data;
          console.log('jiraBoards', response.data);
          // seft.pimDATA = response.data.data;
          seft.itemsBoard = response.data.data;
          seft.overlay = false;
        });
    },
    async boardChange(){
      const seft = this;
      seft.isBtnDisable = true;
      seft.overlay = true;
      this.efforJsonList.boardId = seft.valueBoard.id;
      await axios
        .post(`${config.API_JIRA}/api/jiraProjects`, this.efforJsonList)
        .then(async function (response) {
          // seft.hotSettings.data = response.data.data;
          console.log('itemsProject', response.data);
          // seft.pimDATA = response.data.data;
          seft.itemsProject = response.data.data;
          seft.isBtnDisable = false;
          seft.overlay = false;
        });
    },
    async createWeeklyReport() {
      const seft = this;
      seft.isBtnDisable = true;
      seft.overlay = true;
      seft.$refs.hotTableComponent.hotInstance.loadData([]);
      this.efforJsonList.from =  this.date;
      this.efforJsonList.to = this.date2;
      this.efforJsonList.itemsProject = this.itemsProject;
      this.efforJsonList.team = this.team;
      // this.projectsName = 'SmartLink [Internal]'
      this.efforJsonList.itemsMember = this.itemsMember;

      await axios
        .post(`${config.API_JIRA}/api/jiraNewTicketsReport`, this.efforJsonList)
        .then(async function (response) {
          // seft.hotSettings.data = response.data.data;
          // console.log('pimDATA', seft.pimDATA);
          // seft.pimDATA = response.data.data;
          if(response.data.data != undefined && response.data.data.length > 0){
            await seft.$refs.hotTableComponent.hotInstance.loadData(
              response.data.data
            );
          }else{
            
          }
          seft.isBtnDisable = false;
          seft.overlay = false;

          
          // seft.$refs.hotTableComponent.hotInstance.loadData(seft.pimDATA);
        }).catch((error) => {
            if( error.response ){
              console.log(error.response.data); // => the response payload 
              seft.isBtnDisable = false;
              seft.overlay = false;
            }
        });
    },
    async getWorklogByTicket(){
      const seft = this;
      seft.isBtnDisable = true;
      seft.overlay = true;
      this.efforJsonList.boardId = seft.valueBoard.id;
      this.efforJsonList.ticketid = this.efforJsonList.jiraDev;
     
      await axios
        .post(`${config.API_JIRA}/api/getIssueWorklogs`, this.efforJsonList)
        .then(async function (response) {
          // seft.hotSettings.data = response.data.data;
          console.log('itemsProject', response.data);
          // seft.pimDATA = response.data.data;
          seft.isBtnDisable = false;
          seft.ticketJson =  response.data;
          seft.overlay = false;

          console.log("getWorklogByTicket");
          seft.$refs.hotTableSOGLogs.hotInstance.loadData([]); 
         
          let logs = response.data.data;
          if(logs != undefined && logs.length > 0){
            let arr = [];
            let total = 0;
            for(var i = 0; i < logs.length; i++){
              arr.push({
                "displayName": logs[i].author.displayName,
                "userId": logs[i].author.name,
                "timeSpent":logs[i].timeSpent,
                "updated": moment(logs[i].updated).format("YYYY-MM-DD HH:MM"),
                "comment": logs[i].comment,
              });
              total += logs[i].timeSpentSeconds;
            }
            seft.jiraIdTotalHour = total/60/60;
            seft.$refs.hotTableSOGLogs.hotInstance.loadData(arr);
            console.log("getWorklogByTicket", logDatas[0].worklogList);
          }
          
        });
    },
    getWorklogByTicketOfline (sources, data, jiraId) {
      console.log("getWorklogByTicketOfline");
      this.$refs.hotTableSOGLogs.hotInstance.loadData([]); 
      let logDatas = sources.filter(function(item) { 
        return item.jiraId === jiraId; 
      });
      this.jiraIdSeleted = logDatas[0].key
      let logs = logDatas[0].worklogList;
      if(logs != undefined && logs.length > 0){
        let arr = [];
        let total = 0;
        for(var i = 0; i < logs.length; i++){
          arr.push({
            "displayName": logs[i].author.displayName,
            "userId": logs[i].author.name,
            "timeSpent":logs[i].timeSpent,
            "updated": moment(logs[i].updated).format("YYYY-MM-DD HH:MM"),
            "comment": logs[i].comment,
          });
          total += logs[i].timeSpentSeconds;
        }
        this.jiraIdTotalHour = total/60/60;
        this.$refs.hotTableSOGLogs.hotInstance.loadData(arr);
        console.log("getWorklogByTicketOfline", logDatas[0].worklogList);
      }
    },

    async checkKPI(){
      //Start
      let self = this;
      // Link: https://docs.google.com/spreadsheets/d/1VswUjw73GjsVGkvsPvkbt-DC691RAdQsVQArBgxUZAA/edit#gid=1209211168
      let sheet = {
        "sheetId": "1VswUjw73GjsVGkvsPvkbt-DC691RAdQsVQArBgxUZAA",
        "infos": {
          // "name": ["Check_Files", "CKH_SLO_SML", "CKH_SOG_SML", "SOG_SLO"],
           "name": ["CKH_SLO_SML"],
          "offset": 2,
          "row_limit": 1000
        },
        "monthDifference": this.monthDifference,
      };
      //178Yznh4Kl7DMQBCCy9dbWcedCVXF_NLQ1UjB3GCAZ1c
      self.overlay = true;

      await axios
        .post(`${config.API_JIRA}/api/readSheet`, sheet)
        .then(async function (response) {
          var seriArr = [];
          var seriLabel = [];
          var data = response.data.data;
          let lstChkWorkLog = [];

          // let smlCheckWorkLog = data.filter(function (item) {
          //   if (item.sheetName == 'Check_Files') return true
          // });
          let sloCheckWorkLog = data.filter(function (item) {
            if (item.sheetName == 'CKH_SLO_SML') return true
          });

          // let sogCheckLog = data.filter(function (item) {
          //   if (item.sheetName == 'SOG_SLO') return true
          // });

          // let sloSheet = data.filter(function (item) {
          //   if (item.sheetName == 'CKH_SOG_SML') return true
          // });
          // self.Sheet1 = bug_improvement[0];
          //Only processing
          // smlCheckWorkLog = smlCheckWorkLog[0].sheetData;
         
          // sogCheckLog = sogCheckLog[0].sheetData;
          //sloCheckWorkLog: 4 Dung, 5 Khanh, 6 Nam
         
          //Dung: 11,12; Khanh: 13,14; Nam: 15,16
          if(sloCheckWorkLog != undefined && sloCheckWorkLog != undefined){
             sloCheckWorkLog = sloCheckWorkLog[0].sheetData;
              console.log("sloCheckWorkLog", sloCheckWorkLog);
            let itemLogNam = null;
            let itemLogDung = null;
            let itemLogKhanh = null;
            let sloLog = null;
            let sgoLog = null;
            /**New
             * 
             */
             //get list biz day
          var startDate =  moment(new Date()).add((-1)*self.monthDifference, 'month').startOf('month');
          if(self.monthDifference <= 1){
             startDate =  moment().clone().startOf('month');
          }
          // var endDate = moment('2021-05-31');
          
          let endDate =  moment(new Date());
          
          let dateList = self.getDaysBetweenDates(startDate, endDate);
          console.log("dateList", dateList);
          let memberTotal = null;
          //end get list
            for(var i = 0; i < dateList.length; i++){
            // for(var i = 0; i < sloCheckWorkLog.length; i++){
              // sloLog = sloCheckWorkLog.map(effort => effort[0] == smlCheckWorkLog[i][1]);
              if(dateList[i].trim().length > 0){
                // if(sloCheckWorkLog[i][1].trim().length > 0){
                startDate =  moment(startDate).format("YYYY-MM");
                // let sheetDate =  moment(sloCheckWorkLog[i][1]).format("YYYY-MM");
                endDate =  moment(endDate).format("YYYY-MM");
                sgoLog = null;
                sloLog = null;
                console.log("startDate", startDate);
                // console.log("sheetDate", sheetDate);
                console.log("endDate", endDate);
                for(var j = 0; j < sloCheckWorkLog.length; j++){
                  if(sloCheckWorkLog[j][1] === dateList[i]){
                    sloLog = sloCheckWorkLog[j];
                    if(sloLog != undefined && sloLog != null){
                      break;
                    }
                    
                  }
                }
                // if(sheetDate >= startDate && sheetDate <= endDate){
                  console.log("sheetDate >= startDate && sheetDate <= endDate", true);

                  //Check SLO
                  // for(var j = 0; j < sloCheckWorkLog.length; j++){
                  //   if(sloCheckWorkLog[j][1] == smlCheckWorkLog[i][1]){
                  //     sloLog = sloCheckWorkLog[j];
                  //     console.log("sloLog", sloCheckWorkLog[j]);
                  //     break;
                  //   }
                  // }
                  // for(var j = 0; j < sogCheckLog.length; j++){
                  //   if(sogCheckLog[j][1] === dateList[i]){
                  //     sgoLog = sogCheckLog[j];
                  //     if(sgoLog != undefined && sgoLog != null){
                  //      break;
                  //     }
                      
                  //   }
                  // }
                  itemLogNam = {
                      "userId": "",
                      "displayName": "Nam Nguyen Ngoc",
                      "effortDate": dateList[i],
                      "sloEstEffort": "",
                      "sloActEffort": sloLog != null ? sloLog[5] : 0,
                      "sogActEffort": sloLog != null ? sloLog[11] : 0,
                      // "smlEstEffort": smlCheckWorkLog[i][14],
                      // "smlActEffort": smlCheckWorkLog[i][15],
                      
                    };
                    itemLogDung = {
                      "userId": "",
                      "displayName": "Dung Cao",
                      "effortDate": dateList[i],
                      "sloEstEffort": "",
                      "sloActEffort": sloLog != null ? sloLog[3] : 0,
                      "sogActEffort": sloLog != null ? sloLog[9] : 0,
                      // "smlEstEffort": smlCheckWorkLog[i][10],
                      // "smlActEffort": smlCheckWorkLog[i][11],
                      
                    };
                    itemLogKhanh = {
                      "userId": "",
                      "displayName": "Khanh Nguyen",
                      "effortDate": dateList[i],
                      "sloEstEffort": "",
                      "sloActEffort": sloLog != null ? sloLog[4] : 0,
                      "sogActEffort": sloLog != null ? sloLog[10] : 0,
                      // "smlEstEffort": smlCheckWorkLog[i][12],
                      // "smlActEffort": smlCheckWorkLog[i][13],
                    };

                  //Check SOg
                  lstChkWorkLog.push(itemLogNam);
                  lstChkWorkLog.push(itemLogDung);
                  lstChkWorkLog.push(itemLogKhanh);
                  
                // }  
              }
            }
            
            //End new
            // for(var i = 0; i < smlCheckWorkLog.length; i++){
            //   // sloLog = sloCheckWorkLog.map(effort => effort[0] == smlCheckWorkLog[i][1]);
            //   if(smlCheckWorkLog[i][1].trim().length > 0){
            //     let startDate =  moment(new Date()).add((-1)*self.monthDifference, 'month').format("YYYY-MM");
            //     let sheetDate =  moment(smlCheckWorkLog[i][1]).format("YYYY-MM");
            //     let endDate =  moment(new Date()).format("YYYY-MM");
            //     console.log("startDate", startDate);
            //     console.log("sheetDate", sheetDate);
            //     console.log("endDate", endDate);

            //     if(sheetDate >= startDate && sheetDate <= endDate){
            //       //Check SLO
            //       for(var j = 0; j < sloCheckWorkLog.length; j++){
            //         if(sloCheckWorkLog[j][1] == smlCheckWorkLog[i][1]){
            //           sloLog = sloCheckWorkLog[j];
            //           console.log("sloLog", sloCheckWorkLog[j]);
            //           break;
            //         }
            //       }

            //       //Check SOg
            //       for(var j = 0; j < sogCheckLog.length; j++){
            //         if(sogCheckLog[j][1] == smlCheckWorkLog[j][1]){
            //           sgoLog = sogCheckLog[j];
            //           console.log("sgoLog", sogCheckLog[j]);
            //           break;
            //         }
            //       }

            //       itemLogNam = {
            //         "userId": "",
            //         "displayName": "Nam Nguyen Ngoc",
            //         "effortDate": smlCheckWorkLog[i][1],
            //         "sloEstEffort": "",
            //         "sloActEffort": sloLog != null ? sloLog[5] : 0,
            //         "sogActEffort": sgoLog != null ? sgoLog[5] : 0,
            //         "smlEstEffort": smlCheckWorkLog[i][14],
            //         "smlActEffort": smlCheckWorkLog[i][15],
                    
            //       };
            //       itemLogDung = {
            //         "userId": "",
            //         "displayName": "Dung Cao",
            //         "effortDate": smlCheckWorkLog[i][1],
            //         "sloEstEffort": "",
            //         "sloActEffort": sloLog != null ? sloLog[3] : 0,
            //         "sogActEffort": sgoLog != null ? sgoLog[3] : 0,
            //         "smlEstEffort": smlCheckWorkLog[i][10],
            //         "smlActEffort": smlCheckWorkLog[i][11],
                    
            //       };
            //       itemLogKhanh = {
            //         "userId": "",
            //         "displayName": "Khanh Nguyen",
            //         "effortDate": smlCheckWorkLog[i][1],
            //         "sloEstEffort": "",
            //         "sloActEffort": sloLog != null ? sloLog[4] : 0,
            //         "sogActEffort": sgoLog != null ? sgoLog[4] : 0,
            //         "smlEstEffort": smlCheckWorkLog[i][12],
            //         "smlActEffort": smlCheckWorkLog[i][13],
            //       };
            //       lstChkWorkLog.push(itemLogNam);
            //       lstChkWorkLog.push(itemLogDung);
            //       lstChkWorkLog.push(itemLogKhanh);
            //     }  
            //   }
            // }

          }
          // bug_improvement_processing = bug_improvement_processing[0].sheetData.filter(function (item) {
          //   if (item[12] != 'Finished' && item[12] != 'No Bug') return true
          // })
          await self.$refs.hotTableSOGLogs.hotInstance.loadData(lstChkWorkLog);
          // await self.$refs.hotSettingsSOLKPI.hotInstance.loadData(sloSheet);
          
          self.overlay = false;
         


          //Load SLO Input
         
      });
      // await self.loadExcel("SLO");
    },//End check KPI
    async loadExcel(type){
      // let self = this;
      // let sheet = {
      //   // "sheetId": "1RC16v5kThUGZxwV_D6gfNkpXoGHWpvrfetBogamGgSI",
      //   // "infos": {
      //   //   "name": ["Smartlink"],
      //   //   "offset": 2,
      //   //   "row_limit": 2000
      //   // },
      //   // "monthDifference": this.monthDifference,
        
      // };
      // await axios
      //   .post(`${config.API_JIRA}/api/readSheet`, sheet)
      //   .then(async function (response) {
      //       var data = response.data.data;
      //       let smlCheckWorkLog = data.filter(function (item) {
      //         if (item.sheetName == 'Smartlink') return true
      //       });
      //        console.log("Smartlink", smlCheckWorkLog);
      //      await self.$refs.hotSettingsSOLKPI.hotInstance.loadData(smlCheckWorkLog);
      //   })
    },
    stsSRCRender(instance, td, row, col, prop, value, cellProperties) {
      Handsontable.renderers.TextRenderer.apply(this, arguments);
        let dataSOL = instance.getDataAtCell(row, 3);
        let dataSOG = instance.getDataAtCell(row, 4);
        let dataSML = instance.getDataAtCell(row, 5);
        if(col==3 || col==4){
          td.style.background = '#F0F0F0';
        }
        if(dataSOL != dataSOG){
          td.style.background = 'Orange';
        }
        else if(dataSOG == 0 || dataSOL == 0){
          td.style.background = '#FA8072';
        }
        else if(dataSML != dataSOL){
          // td.style.background = 'Yellow';
        }
      
    },
    weeklyRender(instance, td, row, col, prop, value, cellProperties) {
      Handsontable.renderers.TextRenderer.apply(this, arguments);
      let newReq = instance.getDataAtCell(row, 7);
      console.log("newReq", newReq);
      if(newReq == "New"){
        td.style.background = '#228B22';
      }
      // if(col == 1){
      //   let date = instance.getDataAtCell(row, 1);
      //   td.innerHTML = this.getWklyreport(date);

      // }
      
    },
    rowEvent(instance, td, row, col, prop, value, cellProperties) {
      Handsontable.renderers.TextRenderer.apply(this, arguments);
      td.style.background = '#F0F0F0';
    },
    getDaysBetweenDates(startDate, endDate) {
        var now = startDate.clone(), dates = [];
  
        while (now.isSameOrBefore(endDate)) {
            if(moment(now.format('YYYY-MM-DD'),'YYYY-MM-DD').isBusinessDay()){
              dates.push(now.format('YYYY-MM-DD'));

            }
            now.add(1, 'days');
        }
        return dates;
    },
    
  },
};

</script>
<style scoped>
  .v-data-table {
    width: 100%;
  }
  .v-top {
    vertical-align: top;
  }
  .v-data-table tr td {
    vertical-align: top;
  }
  .v-data-table tr:hover,
  .v-data-table tbody tr:hover:not(.v-data-table__expanded__content) {
    background: #fff !important;
  }
  .menu__content{
    z-index: 9999 !important;
  }
  .v-overlay--active{
    z-index: 9999 !important;
  }

</style>
